﻿Public Class clsDrawingObjectFE

   Inherits clsDrawingObject

   Public Sub New(Owner As clsDrawingPanel)
      MyBase.New(Owner)
   End Sub

   Friend Overloads Overrides Sub Paint(G As Graphics)
      If G Is Nothing Then Exit Sub
      Using P As New Pen(Brushes.Black, 1)
         Using PP As New Pen(Brushes.SlateGray, 1)
            Dim PaintRec As Rectangle = Me.Bounds
            'If Me.isSelected Then
            '    PaintRec = New Rectangle(Me.Bounds.X - Me.MouseOffset.X,
            '                                Me.Bounds.Y - Me.MouseOffset.Y,
            '                                Me.Bounds.Width, Me.Bounds.Height)
            'End If
            G.FillEllipse(Brushes.White, New Rectangle(Me.OldLocation, Me.Bounds.Size))
            G.DrawEllipse(PP, New Rectangle(Me.OldLocation, Me.Bounds.Size))

            If Me.isSelected Then
               G.FillEllipse(Brushes.YellowGreen, PaintRec)
            ElseIf Me.isHovered Then
               G.FillEllipse(Brushes.OrangeRed, PaintRec)
            ElseIf Me.isHighlighted Then
               If Not Me.ConnectedTo Is Nothing Then
                  If Me.ConnectedTo.isSelected Then
                     G.FillEllipse(Brushes.Orange, PaintRec)
                  Else
                     G.FillEllipse(Brushes.Yellow, PaintRec)
                  End If
               Else
                  G.FillEllipse(Brushes.RoyalBlue, PaintRec)
               End If
            End If

            G.DrawEllipse(P, PaintRec)

            Dim FEName As String = Me.Name & " " & IIf(Me.isSelected, "S ", "").ToString & IIf(Me.isHovered, "H", "").ToString & IIf(Me.isHighlighted, "L", "").ToString
            Dim FENameSize As SizeF = G.MeasureString(FEName, Owner.Font)
            Me.DrawingBounds = New Rectangle(Bounds.Location, Bounds.Size + FENameSize.ToSize)
            G.DrawString(FEName, Owner.Font, P.Brush, Me.Location.X + PaintRec.Width * 2, Me.Location.Y)
         End Using
      End Using
   End Sub

End Class
